const safelinksRegexp = new RegExp(
    'https?://[^.]+[.]safelinks[.]protection[.]outlook[.]com/[?]url=([^&]+)&.*',
    'gi'
);

function untangleLink(link) {
    return link.replaceAll(
	safelinksRegexp, (match, url) => {
	    try {
		return decodeURIComponent(url);
	    }
	    catch (e) {
		console.log(e);
		return url;
	    }
	});
}

function isTangledLink(link) {
    return link.match(safelinksRegexp);
}

function getTextNodes(elem) {
    var result = [];
    if (elem) {
	for (var nodes = elem.childNodes, i = nodes.length; i--;) {
	    let node = nodes[i];
	    let nodeType = node.nodeType;
	    
	    if (nodeType == Node.TEXT_NODE) {
		result.push(node);
	    }
	    else if (nodeType == Node.ELEMENT_NODE
		     || nodeType == Node.DOCUMENT_NODE
		     || nodeType == Node.DOCUMENT_FRAGMENT_NODE) {
		result = result.concat(getTextNodes(node));
	    }
	}
    }
    return result;
}
